; \[TA Music Player for PC-88VA series
;  (for NASM)

		USE16
		CPU	186

		ORG	0x0100

; x`
; -----------------
CR		equ	0x0d
LF		equ	0x0a
NULL		equ	0x00
TAB		equ	0x09

; sJn
; ============================================================================
start:		cld
		mov	[cs:backup_sp],sp	; X^bNۑ
		mov	[cs:backup_ss],ss
		mov	ax,0xffff		; VA̋@픻
		mov	es,ax
		cmp	byte [es:0x000f],0xff
		jz	.va
		xor	dx,dx
		in	al,dx
		or	al,al
		jnz	.va
.pc98:		mov	ah,0x09
		mov	dx,errmsg_notva		; xbZ[W\
		int	0x21
		mov	ax,0x4cff		; DOSɖ߂
		int	0x21

.va:		mov	sp,stack		; [JX^bNݒ
		mov	si,title_msg		; N\
		call	print_msg

; R}hC
; ============================================================================
cmd_analyze:	xor	bx,bx
		mov	si,0x0080
		mov	bl,[si]			; 擾
		or	bl,bl
		jnz	.next			; Xy[XȂƂ
		jmp	usage

.next:		inc	si
		mov	byte [bx+si],NULL	; I[NULL𖄂ߍ

analyze_loop:	call	getchar
		or	al,al			; I[
		jnz	checkfile
		jmp	usage

checkfile:	mov	al,[si+1]		; ʂȃf[^t@C2߂Ŕ
		or	al,0x020
		cmp	al,'s'
		jz	opna_check
		cmp	al,'n'
		jz	load_driver
		jmp	err_musfile

opna_check:	inc	byte [opna_music]
		mov	al,0x0ff		; TEh{[hII`FbN
		out	0x0044,al
		in	al,0x0045
		dec	al
		jz	load_driver
		jmp	err_nosb2

load_driver:	mov	[loadfilename],si	; ȃf[^t@C̃|C^ۑ

		mov	bx,code_end
		shr	bx,4
		inc	bx
		push	cs
		pop	es
		mov	ah,0x4a			; [DOS] ubN̏k(ES:BX)
		int	0x21
		jnc	.next
		jmp	err_memory

.next:		mov	bx,0x2000		; 128KB
		mov	ah,0x48			; [DOS] 蓖
		int	0x21
		jnc	bios1_load
		jmp	err_memory

bios1_load:	mov	[driver1_seg],ax	; 蓖ăAhXۑ
		mov	[init_entry+2],ax
		mov	bx,ax
		add	ax,0x1000		; BIOSS/BIOSS2p̃ZOg(+1000H)
		mov	[driver2_seg],ax

		mov	si,biosd_file		; BIOSD t@C̃[h
		call	file_load
		jnc	bios2_load
		jmp	err_load

bios2_load:	call	print_msg
		mov	si,load_ok
		call	print_msg

		mov	bx,[driver2_seg]	; [hZOg
		mov	si,bioss_file
		cmp	byte [opna_music],0x01
		jnz	.next
		mov	si,bioss2_file
.next:		call	file_load		; BIOSS/BIOSS2̃[h
		jnc	dsefc_load
		jmp	err_load

dsefc_load:	call	print_msg
		mov	si,load_ok
		call	print_msg

		mov	bx,[driver2_seg]
		add	bx,0x0100		; ItZbg0x1000
		mov	si,dsefc_file
		call	file_load		; DSEFC̃[h
		jnc	music_load
		jmp	err_load

music_load:	call	print_msg
		mov	si,load_ok
		call	print_msg

		mov	bx,[driver2_seg]	; TEhhCoZOg
		add	bx,0x0180		; ItZbg0x1800
		mov	si,[loadfilename]	; ȃf[^t@C
		call	file_load		; ȃf[^[hs
		jnc	segment_patch
		jmp	err_load

segment_patch:	call	print_msg
		mov	si,load_ok
		call	print_msg

		mov	si,driver1_seg
		mov	es,[driver2_seg]
		mov	di,0x0170		; BIOSS2p
		cmp	byte [opna_music],0x01
		jz	.next
		mov	di,0x010f		; BIOSSp
.next:		movsw				; zuZOg
		movsw

initialize:	xor	ax,ax			; ݃xN^ۑ
		mov	ds,ax
		push	cs
		pop	es
		mov	di,backup_vecrtc
		mov	si,0x08*4		; PIT݃xN^
		movsw
		movsw
		mov	si,0x14*4		; FM݃xN^
		movsw
		movsw
		mov	si,0x40*4		; INT 40xN^
		mov	cx,2*8
		rep	movsw			; INT 40`47܂ŃxN^ޔ
		mov	si,0xd0*4		; INT D0xN^
		mov	cx,2*3
		rep	movsw			; INT D0`D2܂ŃxN^ޔ

		xor	ax,ax			; INT 40`47܂ŃxN^tbN
		mov	es,ax
		push	cs
		pop	ds
		mov	si,0x40*4
		mov	di,intvec_40
		mov	cx,8
		mov	bx,[driver1_seg]
.vecset_loop:	lodsw
		stosw
		mov	ax,bx
		stosw
		loop	.vecset_loop

		push	ds
		mov	ax,0x25d2		; INT D2xN^tbN
		mov	dx,0x0200
		mov	ds,[driver2_seg]
		int	0x21
		pop	ds

		mov	dx,0x0186
		in	al,dx			; ݃}XNۑ
		xchg	ah,al
		mov	dx,0x018a
		in	al,dx
		mov	[pic_mask_m],ax

		mov	ax,[driver1_seg]
		mov	ds,ax
		mov	es,ax
		mov	byte [0x0e2d],0x78	; L[{[h݂
		mov	byte [0x0ea3],0xc3	; RET𖄂ߍ(L[{[hׂ)
		mov	byte [0x0e39],0xcb	; RETF𖄂ߍ
		call	far [cs:init_entry]	; TEhhCo
		mov	ax,cs
		mov	ds,ax
		mov	es,ax

		xor	al,al			; tJn
		int	0xd2

		mov	si,play_ok
		call	print_msg

keywait_loop:	mov	ah,0x09			; 1 (L[҂)
		int	0x82			; L[{[hBIOSĂяo

		cmp	al,0x1b			; ESCL[ŉtI
		jz	stop

		mov	bl,al			; At@xbg̔
		or	al,0x20			; ɕϊ
		sub	al,'a'
		jb	.next
		cmp	al,'z'
		jbe	effect

.next:		mov	al,bl			; ̔
		sub	al,'0'
		jb	keywait_loop
		cmp	al,'9'
		ja	keywait_loop

effect:		push	ds
		mov	ds,[driver1_seg]
		mov	[0x085a],al		; ʉԍ
		pop	ds
		jmp	short keywait_loop	; L[҂ɖ߂

stop:		mov	al,0x03
		int	0xd2			; t~

		cli
		xor	ax,ax
		mov	es,ax
		push	cs
		pop	ds
		mov	si,backup_vecrtc
		mov	di,0x08*4		; PIT݃xN^߂
		movsw
		movsw
		mov	di,0x14*4		; FM݃xN^߂
		movsw
		movsw
		mov	di,0x40*4		; INT 40`47xN^߂
		mov	cx,8
.loop1:		movsw
		movsw
		loop	.loop1
		mov	di,0xd2*4		; INT D0`D2xN^߂
		mov	cx,3
.loop2:		movsw
		movsw
		loop	.loop2

		mov	ax,[pic_mask_m]
		mov	dx,0x018a
		out	dx,al			; ݃}XN߂
		xchg	al,ah
		mov	dx,0x0186
		out	dx,al
		sti
		xor	al,al			; I (code=0)

exit:		call	rel_memory		; J
to_dos:		cli
		mov	sp,[cs:backup_sp]	; X^bN߂
		mov	ss,[cs:backup_ss]
		sti
		mov	ah,0x4c			; DOSɖ߂
		int	0x21


; eG[
; ============================================================================

usage:		mov	si,usage_msg		; g\ďI
		call	print_msg
		mov	al,0xff
		jmp	to_dos

err_memory:	mov	si,errmsg_memory	; 蓖ăG[
		call	print_msg
		mov	al,0x01			; ُI (code=1)
		jmp	to_dos

err_load:	call	print_msg		; [hɎst@C
		mov	si,errmsg_load		; t@Cǂݍ߂ȂG[
		call	print_msg
		call	rel_memory		; J
		mov	al,0x02			; ُI (code=2)
		jmp	to_dos

err_musfile:	mov	si,errmsg_musfile	; ȃf[^`łȂG[
		call	print_msg
		mov	al,0x04			; ُI (code=4)
		jmp	to_dos

err_nosb2:	mov	si,errmsg_nosb2		; TEh{[h2݂ȂG[
		call	print_msg
		mov	al,0x05			; ُI (code=5)
		jmp	to_dos


; 蓖ĂꂽΊJ
; ============================================================================

rel_memory:	push	ax
		push	es
		mov	ax,[driver1_seg]
		or	ax,ax
		jz	.noerror
		mov	es,ax
		mov	ah,0x49			; 蓖ĂJ
		int	0x21
		jnc	.noerror
		mov	si,errmsg_memrel	; JsG[\
		call	print_msg
		stc
.noerror:	pop	es
		pop	ax
		ret

; t@C[h
; []
; DS:SI = t@C̃|C^
; BX    = obt@ZOg
; ============================================================================

file_load:	mov	[.buffer_seg],bx
		mov	ax,0x3d00		; t@CI[v
		mov	dx,si
		int	0x21
		jc	.error
		mov	[.load_fh],ax		; t@Cnhۑ
		xchg	bx,ax
		push	ds
		mov	ax,[.buffer_seg]
		mov	ds,ax			; t@C[h
		xor	dx,dx
		mov	cx,0xffff
		mov	ah,0x3f
		int	0x21
		pop	ds
		jc	.error
		mov	bx,[.load_fh]		; t@CN[Y
		mov	ah,0x3e
		int	0x21
		mov	bx,[.buffer_seg]
		clc
.error:		ret

.load_fh:	dw	0x0000			; t@Cnh
.buffer_seg:	dw	0x0000			; [hobt@ۑp

; R}hC̃Xy[X/^uǂݔ΂
; []
;  DS:SI = R}hC̃|C^
; [߂l]
;  AL = ŌɎ擾
; ============================================================================
getchar:	lodsb
		cmp	al,' '
		jz	getchar
		cmp	al,TAB
		jz	getchar
		dec	si
		ret

; \
; []   DS:SI = 
;------------------------------------------------------------------------------
print_msg:	mov	ah,0x02
		mov	dh,0x80
		int	0x83
		ret

; f[^/[N
; ============================================================================

backup_sp:	dw	0x0000			; X^bNۑp
backup_ss:	dw	0x0000

backup_vecrtc:	dw	0x0000			; ݃xN^ۑp[N
		dw	0x0000
backup_vecfm:	dw	0x0000
		dw	0x0000
backup_vec40:	dw	0x0000
		dw	0x0000
backup_vec41:	dw	0x0000
		dw	0x0000
backup_vec42:	dw	0x0000
		dw	0x0000
backup_vec43:	dw	0x0000
		dw	0x0000
backup_vec44:	dw	0x0000
		dw	0x0000
backup_vec45:	dw	0x0000
		dw	0x0000
backup_vec46:	dw	0x0000
		dw	0x0000
backup_vec47:	dw	0x0000
		dw	0x0000
backup_vecd0:	dw	0x0000
		dw	0x0000
backup_vecd1:	dw	0x0000
		dw	0x0000
backup_vecd2:	dw	0x0000
		dw	0x0000

intvec_40:	dw	0x1071			; ݃xN^ItZbg(INT 0x40`0x47)
intvec_41:	dw	0x0ef4
intvec_42:	dw	0x1036
intvec_43:	dw	0x0ea2
intvec_44:	dw	0x0ea2
intvec_45:	dw	0x0ea2
intvec_46:	dw	0x0ffd
intvec_47:	dw	0x1046

mute_data:	dw	0x0800			; pf[^
		dw	0x0900
		dw	0x0a00
		dw	0x2800
		dw	0x2801
		dw	0x2802
		dw	0x2804
		dw	0x2805
		dw	0x2806
		dw	0xffff

pic_mask_m:	db	0x00			; ݃}XNۑp
pic_mask_s:	db	0x00

loadfilename:	dw	0x0000			; t@C̃|C^

driver1_seg:	dw	0x0000			; BIOSDpɊ蓖ĂZOg
driver2_seg:	dw	0x0000			; BIOSS/S2pɊ蓖ĂZOg

init_entry:	dw	0x0e22			; Gg
		dw	0x0000

opna_music:	db	0x00			; OPNAȂ̉tw

load_ok:	db	' LOAD OK!',CR,LF,NULL
musload_ok:	db	'MUSIC DATA LOAD OK!',CR,LF,NULL
play_ok:	db	'NOW PLAYING...',CR,LF
		db	'[ESC]:END    [A]-[Z],[0]-[9]:EFFECT',CR,LF,NULL

biosd_file:	db	'BIOSD',NULL
bioss_file:	db	'BIOSS',NULL
bioss2_file:	db	'BIOSS2',NULL
dsefc_file:	db	'DSEFC',NULL

title_msg:	db	'SORCERIAN for PC-88VA Music Player version 0.1',CR,LF,NULL
usage_msg:	db	'Usage:  SORCPLAY [filename]',CR,LF,NULL

errmsg_memory:	db	'̊蓖Ăo܂.',CR,LF,NULL
errmsg_musfile:	db	'TEhf[^̎ʂł܂.',CR,LF,NULL
errmsg_nosb2:	db	'TEh{[h2݂܂.',CR,LF,NULL
errmsg_load:	db	't@C̓ǂݍ݂Ɏs܂.',CR,LF,NULL
errmsg_memrel:	db	'̊JɎs܂.',CR,LF,NULL
errmsg_notva:	db	'PC-88VAV[YȊOł͎sł܂.',CR,LF,'$'

		times 0x100 db 0x00	; X^bNGA
stack:
		align	0x10

code_end:
		ends

